//-*-c++-*------------------------------------------------------------
//
// File name : bioArithElementaryExpression.h
// Author :    Michel Bierlaire
// Date :      Sat Apr 16 14:27:34 2011
//
//--------------------------------------------------------------------

#ifndef bioArithElementaryExpression_h
#define bioArithElementaryExpression_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing an elementary expression, without any chil
*/
class bioArithElementaryExpression : public bioExpression {

public:
  
  bioArithElementaryExpression(bioExpressionRepository* rep, patULong par) ;

  ~bioArithElementaryExpression() ;

public:

  virtual patBoolean isSimple() const ;
  virtual patULong getNumberOfOperations() const ;

  virtual void forceCodeGeneration() ;
  virtual patBoolean containsAnIterator() const ;
  virtual patBoolean containsAnIntegral() const ;
  virtual patBoolean containsASequence() const ;

  virtual patString getExpression(patError*& err) const ;
  virtual bioExpression* getExpressionFromId(patULong theId) ;
  virtual void simplifyZeros(patError*& err)  ;
  virtual void generateGslFunctions(ostream& str_h,patString prefix,patError*& err)  ;
  virtual patString getIncludeStatements(patString prefix) const  ;

  virtual void setVariables(const patVariables* x) ;
  virtual void setDraws(const vector< vector<patReal> >* d) ;
  virtual void setSample(const bioSample* s) ;

  virtual void setCurrentSpan(bioIteratorSpan aSpan) ;
  virtual void setThreadSpan(bioIteratorSpan aSpan) ;

  virtual void collectExpressionIds(set<patULong>* s) const ;
  virtual patString check(patError*& err) const  ;

};

#endif
